/*
 *	app.h
 *
 *	Vvt[cX}bV
 *
 *	* Mon Aug 07 02:45:11 JST 2006 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __APP_H__
#define __APP_H__

#include "supp/supp.h"

/****************************************************************************
 *	
 ****************************************************************************/

/* NbNEEFCgύXꍇ́ATURBOV{`ĂB
 * - `ĺAturbo()֐ɂ̂܂܈n܂B
 */
#define TURBO -1 /*{{TODO}}*/

/* hFǂݍޏꍇ́AUSE_MUSICV{`ĂB
 * - USE_MUSICV{`ȂĂAyt[`͗p\łA
 *   hFst@CɒڃN邽߁At@CTCY傫Ȃ܂B
 */
//#define USE_MUSIC /*{{TODO}}*/

/* |[Y@\gꍇ́AUSE_PAUSEV{`ĂB */
#define USE_PAUSE /*{{TODO}}*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT /*{{TODO}}*/
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/* L`sꍇ́AUSE_CHRV{`Ă */
#define USE_CHR /*{{TODO}}*/
#ifdef USE_CHR
#define CHR_ CHR_INIT1
enum {
#include "chr.h"
};
extern const CHR chr_tbl[];
#undef CHR_
#endif /*USE_CHR*/

/****************************************************************************
 *	
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

#define FIELD_X		29			/* tB[h_W (Z_W) */
#define FIELD_Y		 5

#define CELL_SIZE	10			/* ZTCY */

#define TIMER_X		 1			/* ԕ\W */
#define TIMER_Y		15			/* (sڂ-7) */
#define TIMER_W		23
#define TIMER_H		 5

#define SCORE_X		 1			/* XRA\W */
#define SCORE_Y		35			/* (sڂ-7) */
#define SCORE_W		23
#define SCORE_H		 5

#define LEVEL_X		 1			/* x\W */
#define LEVEL_Y		55			/* (sڂ-7) */
#define LEVEL_W		23
#define LEVEL_H		 5

#define COMBO_X		 1			/* R{\W */
#define COMBO_Y		68			/* (sڂ+7) */
#define COMBO_W		23
#define COMBO_H		12

#define METER_X		118			/* [^[\W */
#define METER_Y		 10
#define METER_W		  3
#define METER_H		 54

#define GO_X		(63-9)
#define GO_Y		(45-9)
#define GO_W		(24+2)
#define GO_H		(16+2)

#define FIELD_COLS	8
#define FIELD_ROWS	8

/* CELL.stat */
//				0		/* ʏ */
#define CELL_STAT_MOVE_LF	1		/* ړ */
#define CELL_STAT_MOVE_RI	2		/* Eړ */
#define CELL_STAT_MOVE_UP	3		/* ړ */
#define CELL_STAT_MOVE_DN	4		/* ړ */
#define CELL_STAT_ERASE		5		/*  */

/* CELL.type */
#define NUM_CELL_TYPES		5		/* t[c̎ */

typedef struct _CELL {
	short type;				/* 0 = , 1`NUM_CELL_TYPES =  */
	short stat;				/*  (CELL_STAT_*) */
	short point;
} CELL;

typedef struct _GAME {
	int timer;				/* c莞 (t[) */
	int prev_timer;				/* O̕\ */

	int score;				/* XRA (x10ĕ\) */
	int prev_score;				/* O̕\ */

	int level;				/* x (+1ĕ\) */
	int prev_level;				/* O̕\ */

	int meter;				/* [^[ */
	int meter_full;				/* [^[̍ől */
	int prev_meter;				/* O̕\ */

	int combo;				/* R{ */
	int combo_disp;				/* R{\ */
	int prev_combo_disp;			/* O̕\ */
	int combo_disp_cnt;			/* c\ */

	int cursor_color;			/* J[\̐F (3=Vtg\, 2=Vtgs) */
	int cursor_blink;			/* ŃJE^ (0`0.3b=, 0.3`0.5b=) */
	int cursor_col;				/* J[\ */
	int cursor_row;				/* J[\s */
	int prev_cursor_x;			/* O̕\XW */
	int prev_cursor_y;			/* O̕\YW */

	int field_cnt;				/* ėpJE^ */
	CELL field[FIELD_ROWS][FIELD_COLS];
} GAME;

/****************************************************************************
 *	
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
void delay(int frame);
int demo_main();
void game_main();

void field_disp_init();
void field_disp();
void cursor_disp();
void cursor_action1();
int cursor_action2();
void clear_move();
int move_back(int stat);
void move_done(int stat);
int erase_test();
int move_test();
void action_done();

/****************************************************************************
 *	
 ****************************************************************************/

extern unsigned char TITLE[];

#include "work.h"

#endif /*__APP_H__*/
