/*
 *	app.h
 *
 *	P/ECE CLiP Library 3D Object Exporter
 *	Copyright (C) 2006 Naoyuki Sawa
 *
 *	* Thu Jun 29 11:46:08 JST 2006 Naoyuki Sawa
 *	- AvP[Vwb_Ƃĕʃt@Cɕ܂B
 */
#define STRICT
#include <windows.h>
#include <commctrl.h>
//
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
//
#include "MQPlugin.h"
#include "resource.h"

#define APP_TITLE	"P/ECE CLiP Library 3D Object Exporter"
#define APP_PRODUCT	0x20060726	/* NƂ܂ */
#define APP_ID		0x08431700	/* bƂ܂ */

/*****************************************************************************
 *	
 *****************************************************************************/

/*{{clipfix.h*/
#define FRACT_BITS	10			/* rbg */
#define FIXED_SCALE	(1 << FRACT_BITS)	/* Œ菬XP[l */
#define fld(a)		((fixed)(int)((a) * FIXED_SCALE))
typedef struct _fixed* fixed;
/*}}clipfix.h*/

/* ExportMesh.cpp */
BOOL DoExportMesh(FILE* fp, MQDocument doc, MQObject obj, struct _OPTION* option);

/* ExportWire.cpp */
BOOL DoExportWire(FILE* fp, MQDocument doc, MQObject obj, struct _OPTION* option);

/* OptionDialog.cpp */
typedef struct _OPTION {
	double scale;	/* g嗦 = scale * pow(10, exp) */
	int exp;
	int axis;	/* 0 = X], 1 = Y], 2 = Z] */
} OPTION;
int DoOptionDialog(HINSTANCE hInstance, HWND hWndParent, OPTION* option);
